import java.io.*;
import java.security.*;

public class MD {
    private static final int MODE_DIGEST=0;
    private static final int MODE_CHECK=1;

    private static void printUsage()throws Exception {
	System.out.println("Usage: MD -digest messagefile digestfile [-algo algoname]");
	System.out.println("Usage: MD -check messagefile digestfile [-algo algoname]");
	System.out.println("Usage: default algo : MD5");
    }
  public static void main(String[] args) throws Exception {



    if (args.length != 3 && args.length != 5) {
	printUsage();
	return;
    }

    String optionsmode= args[0];
    int mode;
    if(optionsmode.equals("-digest")) {
	mode=MODE_DIGEST;
    } else if(optionsmode.equals("-check")) {
	mode=MODE_CHECK;
    } else {
	printUsage();
	return;
    }

    String messagefile = args[1];
    String digestfile = args[2];

    //String optionalgo=null;
    String algoname;

    if (args.length == 5) {
	algoname=args[4];
    } else {
	algoname="MD5";
    }

    // Obtain a message digest object.
    MessageDigest md = MessageDigest.getInstance(algoname);
      
    // Calculate the digest for the given file.
    FileInputStream fis = new FileInputStream(messagefile);
    BufferedInputStream bufin = new BufferedInputStream(fis);
    byte[] buffer = new byte[8192];

    int length;
    while ((length = bufin.read(buffer)) != -1)   {
	md.update(buffer, 0, length);
    };
    bufin.close();
    byte[] dig = md.digest();

    if (mode==MODE_DIGEST) {
	FileOutputStream out = new FileOutputStream(digestfile);
      	out.write(dig);
      	out.close();
    } else {
    	FileInputStream in = new FileInputStream(digestfile);
        byte[] digToCheck = new byte[in.available()];
        in.read(digToCheck);
        in.close();

	if(digToCheck.length==dig.length) {
          int i;
	  for(i=0; i<dig.length && digToCheck[i]==dig[i] ;i++) ;
	  if(i==dig.length) {
          	System.out.println("Correct digest.");
		return;
	  }
	}
        System.out.println("Digest or message is/are CORRUPTED !!!");
    }
  }
}
